# installation used by quickinstaller

from Products.ExternalMethod.ExternalMethod import ExternalMethod
from Products.CMFCore.utils import getToolByName
from Products.Archetypes import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.PloneFormMailer import PROJECTNAME, GLOBALS

from StringIO import StringIO

def install(self):
    out = StringIO()
    classes=listTypes(PROJECTNAME)
    installTypes(self, out,
                 classes,
                 PROJECTNAME)
    install_subskin(self, out, GLOBALS)

    _setWorkflow(self, out)
    _migrateSchema(self, out)
    return out.getvalue()

def _setWorkflow(self, out):
    wft = getToolByName(self,'portal_workflow')
    iwf = ExternalMethod('temp',
                       'temp',
                       PROJECTNAME+'.'+'PloneFormMailer_workflow',
                       'createPloneFormMailer_workflow') 
    wf = iwf(self,'PloneFormMailer_workflow')
    wft._setObject('PloneFormMailer_workflow', wf)
    wft.setChainForPortalTypes( ['PloneFormMailer'], wf.getId())
    print >> out, "Ploneformmailer workflow set."

def _migrateSchema(self, out):
    at = getToolByName(self, 'archetype_tool')
    class dummy:
        form = {}
    dummyRequest = dummy()
    dummy.form['PloneFormMailer.PloneFormMailer'] = 1
    at.manage_updateSchema(update_all=1,
                           REQUEST=dummyRequest)
    print >> out, "Migrated all PFM schemas."
